
public abstract class Point2DAbstract implements Point2D {

	public boolean equals(Object o) {
		if (o instanceof Point2D)
			return equals((Point2D)o);
		return super.equals(o);
	}

	public boolean equals(Point2D p) {
		return getX() == p.getX() && getY() == p.getY();
	}

	public int compareTo(Object o) {
		Point2D p = (Point2D) o;
		if (equals(p))
			return 0;
		if (getX() < p.getX()) 
		    return -1;
		if (getX() > p.getX()) 
		    return  1;
		if (getY() < p.getY()) 
		    return -1;
		// getY() > p.getY()) 
		    return  1;
	}

	public String toString() {
		return " (" + getX() + "," + getY() + ")";
	}

	public void translate(double dx, double dy) {
		setX(getX() + dx);
		setY(getY() + dy);
	}

}

