import java.util.*;

interface SelectionFunction {
    public boolean select(Point2D p);
}

// remplacé par une classe anonyme
// class inDisk implements SelectionFunction {
//     public boolean select(Point2D p) {
// 	double x = p.getX();
// 	double y = p.getY();
// 	return (x-10)*(x-10)+(y-10)*(y-10) < 25;
//     }
// }

class TestCollectionAvecSelection {
    public static Set selection(Set coll, SelectionFunction f){
	Iterator it = coll.iterator();
	Set selection = new TreeSet(); 
	while (it.hasNext()){
	    Point2D p = (Point2D) it.next();
	    if (f.select(p))
		selection.add(p);
	}
	return selection;
    }
	
    public static void main(String argv[]) {
	// création d'un ensemble trié de Point , coordonnées aléatoires
	Random gen = new Random();
		
	Set coll = new TreeSet();
	for (int i=0; i<100; ++i){
	    int x = gen.nextInt(10);
	    int y = gen.nextInt(10);
	    Point2D p = new Point2DArray(x, y);
	    coll.add(p);
	}
	System.out.println(coll);
	    
		
	// Set selection = selection(coll, new inDisk()); 

	// appel avec classe anonyme
	Set selection = selection(coll, new SelectionFunction(){
		public boolean select(Point2D p) {
		    double x = p.getX();
		    double y = p.getY();
		    return (x-10)*(x-10)+(y-10)*(y-10) < 25;
		}});

	System.out.println(selection);
    }
}
